﻿using Infragistics.Win;
using Infragistics.Win.UltraWinEditors;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace EditorComponentSample
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.Load += Form1_Load;
            this.ultraGrid1.InitializeRow += ultraGrid1_InitializeRow;
        }

        private void ultraGrid1_InitializeRow(object sender, Infragistics.Win.UltraWinGrid.InitializeRowEventArgs e)
        {
            if (e.Row.Band == ultraGrid1.DisplayLayout.Bands[0])
            {
                // 바인딩 이후 textbox 값이 변경 되면 다시 InitializeRow이벤트가 발생 한다.
                // ReInitialize가 발생 하면 리턴 시킴
                if (e.ReInitialize) return;

                // UltraTextEditor를 생성
                //UltraTextEditor textEditor = new UltraTextEditor();
                EditorWithText textEditor = new EditorWithText();

                // 상태버튼 생성(CheckBox)
                StateEditorButton stateButton = new StateEditorButton();
                stateButton.Appearance.BackColor = Color.Transparent;

                // 생성한 UltraTextEditor에 상태 버튼을 추가
                textEditor.ButtonsLeft.Add(stateButton);

                // 각 Row마다 EditorComponent로 컨트롤 추가
                //e.Row.Cells["Fourth_Column"].EditorComponent = textEditor;
                e.Row.Cells["Fourth_Column"].Editor = textEditor;
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            SetGridDataBinding();
        }

        private void SetGridDataBinding()
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("First_Column");
            dt.Columns.Add("Second_Column");
            dt.Columns.Add("Third_Column");
            dt.Columns.Add("Fourth_Column");

            DataRow dr1 = dt.NewRow();
            dr1["First_Column"] = "SampleData(1-1)";
            dr1["Second_Column"] = "SampleData(1-2)";
            dr1["Third_Column"] = "SampleData(1-3)";
            dt.Rows.Add(dr1);

            DataRow dr2 = dt.NewRow();
            dr2["First_Column"] = "SampleData(1-1)";
            dr2["Second_Column"] = "SampleData(1-2)";
            dr2["Third_Column"] = "SampleData(1-3)";
            dt.Rows.Add(dr2);

            DataRow dr3 = dt.NewRow();
            dr3["First_Column"] = "SampleData(1-1)";
            dr3["Second_Column"] = "SampleData(1-2)";
            dr3["Third_Column"] = "SampleData(1-3)";
            dt.Rows.Add(dr3);

            this.ultraGrid1.DataSource = dt;
            this.ultraGrid1.DisplayLayout.Bands[0].Columns["Fourth_Column"].ButtonDisplayStyle = Infragistics.Win.UltraWinGrid.ButtonDisplayStyle.Always;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //MessageBox.Show(((Infragistics.Win.UltraWinEditors.StateEditorButton)((UltraTextEditor)ultraGrid1.Rows[0].Cells["Fourth_Column"].EditorComponent).ButtonsLeft[0]).CheckState.ToString());
            //MessageBox.Show(((Infragistics.Win.UltraWinEditors.StateEditorButton)((UltraTextEditor)ultraGrid1.Rows[0].Cells["Fourth_Column"].EditorComponent).ButtonsLeft[0]).Checked.ToString());
            MessageBox.Show(((ultraGrid1.Rows[0].Cells["Fourth_Column"].EditorResolved as EditorWithText).ButtonsLeft[0] as StateEditorButton).Checked.ToString());
        }

        private void button2_Click(object sender, EventArgs e)
        {
            
        }
    }
}
